import java.awt.image.BufferedImage;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.universe.SimpleUniverse;

class Map extends BranchGroup
{
	private Box map;
	private Canvas3D offscreen;
	private ImageComponent2D buffer;
	private View view;

	public Map(View view0,Screen3D screen0)
	{
		addChild(createMap());
		initOffscreenBuffer(view0,screen0);
	}

	private Node createMap()					// n} (̕) ̍쐬
	{
		Appearance appearance;
		TransparencyAttributes transparent;
		TextureAttributes textureAttr;
	
		appearance=new Appearance();
		appearance.setCapability(Appearance.ALLOW_TEXTURE_WRITE);
		transparent=new TransparencyAttributes(
		    TransparencyAttributes.BLENDED,0.5f);
		appearance.setTransparencyAttributes(transparent);
		textureAttr=new TextureAttributes();
		textureAttr.setTextureMode(TextureAttributes.DECAL);
		appearance.setTextureAttributes(textureAttr);
		
		map=new Box(0.15f,0.15f,0.01f,
		    Box.GENERATE_TEXTURE_COORDS | Box.ENABLE_APPEARANCE_MODIFY,
		    appearance);
		
		return map;
	}

	private void initOffscreenBuffer(View view0,Screen3D screen0)
	{
		BufferedImage image;
		Texture texture;
		RenderOffscreenBehavior behavior;
		BoundingSphere bounds;
	
		image=new BufferedImage(256,256,BufferedImage.TYPE_INT_ARGB);
		// Qƌ^ŉ摜ݒ
		buffer=new ImageComponent2D(
		    ImageComponent.FORMAT_RGBA,image,true,true);
		buffer.setCapability(ImageComponent2D.ALLOW_IMAGE_READ);
		
		// ItXN[_O̐ݒ
		offscreen=new Canvas3D(
		    SimpleUniverse.getPreferredConfiguration(),true);
		offscreen.setOffScreenBuffer(buffer);
		
		view=new View();
		view.setPhysicalBody(view0.getPhysicalBody());
		view.setPhysicalEnvironment(view0.getPhysicalEnvironment());
		view.addCanvas3D(offscreen);
		
		offscreen.getScreen3D().setSize(screen0.getSize());
		offscreen.getScreen3D().setPhysicalScreenWidth(
		    screen0.getPhysicalScreenWidth());
		offscreen.getScreen3D().setPhysicalScreenHeight(
		    screen0.getPhysicalScreenHeight());
		
		texture=new Texture2D(Texture.BASE_LEVEL,Texture.RGBA,256,256);
		texture.setImage(0,buffer);
		texture.setCapability(Texture.ALLOW_IMAGE_WRITE);
		map.getAppearance().setTexture(texture);
		
		bounds=new BoundingSphere(new Point3d(),Double.POSITIVE_INFINITY);
		behavior=new RenderOffscreenBehavior(offscreen,texture);
		behavior.setSchedulingBounds(bounds);
		
		addChild(behavior);
	}

	public void attachViewPlatform(ViewPlatform platform)
	{
		view.attachViewPlatform(platform);
	}
}
