import java.util.Enumeration;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.image.TextureLoader;

public class RenderOffscreenBehavior extends Behavior
{
	private Canvas3D offscreen;
	private Texture texture;

	private WakeupCondition wakeupCriterion;

	public RenderOffscreenBehavior(Canvas3D offscreen,Texture texture)
	{
		this.offscreen=offscreen;
		this.texture  =texture;
	}

	public void initialize()
	{
		wakeupCriterion=new WakeupOnElapsedFrames(0);
		wakeupOn(wakeupCriterion);
	}

	public void processStimulus(Enumeration criteria)
	{
		WakeupCriterion criterion;
	
		while (criteria.hasMoreElements())
		{
			criterion=(WakeupCriterion)(criteria.nextElement());
			
			if (criterion instanceof WakeupOnElapsedFrames)
			{
				process((WakeupOnElapsedFrames)(criterion));
			}
		}
		
		wakeupOn(wakeupCriterion);
	}

	private void process(WakeupOnElapsedFrames event)
	{
		offscreen.renderOffScreenBuffer();
		offscreen.waitForOffScreenRendering();
		
		texture.setImage(0,offscreen.getOffScreenBuffer());
	}
}
